﻿local E, L, V, P, G = unpack(ElvUI)
local EP = LibStub("LibElvUIPlugin-1.0")
local Tuk = E:NewModule("Tuk_Style", "AceEvent-3.0")
local LSM = LibStub('LibSharedMedia-3.0')
local CH = E:GetModule('Chat')
local LO = E:GetModule('Layout')
local S = E:GetModule('Skins')
local addon = ...
--GLOBALS: hooksecurefunc, LibStub
local _G = _G

local IsAddOnLoaded = IsAddOnLoaded
local pairs = pairs

V["tukui"] = {
	["actionbars"] = true,
	["forcebordercolor"] = true,
}

Tuk.Version = GetAddOnMetadata('ElvUI_TukUIStyle', 'Version')

function Tuk:SetMoverPosition(frame, anchor, parent, point, x, y)
	if not _G[frame] then return end
	local frame = _G[frame]

	frame:ClearAllPoints()
	frame:SetPoint(anchor, parent, point, x, y)
end

function Tuk:RegisterMedia()
	E['media'].ufFont = LSM:Fetch('font', 'TukUI Unitframes')
	E['media'].abFont = LSM:Fetch('font', 'TukUI Actionbars')
end

function Tuk:StyleSettings()
	if E.private.general.pixelPerfect == true then E.private.general.pixelPerfect = false end
	if E.db.unitframe.thinBorders then E.db.unitframe.thinBorders = false end
	E.PixelMode = false

	E.db.chat.panelBackdrop = "HIDEBOTH"
	E.db.datatexts.leftChatPanel = true
	E.db.datatexts.rightChatPanel = true
	E.db.datatexts.panelTransparency = false
	if IsAddOnLoaded("ElvUI_SLE") then
		E.db.sle.datatexts.chathandle = false
	end

	CH:PositionChat(true)
	CH:UpdateAnchors()
	LO:ToggleChatPanels()
	LO:SetDataPanelStyle()

	E.db.general.bottomPanel = false

	LO:BottomPanelVisibility()
end

function Tuk:Repositioning()
	Tuk:SetMoverPosition("LeftChatPanel", "BOTTOMLEFT", _G["ElvUIParent"], "BOTTOMLEFT", 40, 19)
	Tuk:SetMoverPosition("RightChatPanel", "BOTTOMRIGHT", _G["ElvUIParent"], "BOTTOMRIGHT", -40, 19)

	if E.private.tukui.actionbars then
		Tuk:SetMoverPosition("ElvUI_Bar1", "BOTTOM", _G["ElvUIParent"], "BOTTOM", 0, 16)
	end
end

function Tuk:MoverOff(frame)
	E:DisableMover(frame.mover:GetName())
end

function Tuk:DisableMovers()
	Tuk:MoverOff(_G["ElvUI_ExperienceBar"])
	Tuk:MoverOff(_G["ElvUI_ReputationBar"])
	Tuk:MoverOff(_G["LeftChatPanel"])
	Tuk:MoverOff(_G["RightChatPanel"])
	if E.private.tukui.actionbars then
		Tuk:MoverOff(_G["ElvUI_Bar1"])
	end
	
end

function Tuk:Initialize()
	Tuk:StyleSettings()
	Tuk:DisableMovers()
	Tuk:Repositioning()
	Tuk:RegisterMedia()

	Tuk:CreatePanels()
	Tuk:RepositionExpRep()
	Tuk:SizePanels()
	hooksecurefunc(CH, "PositionChat", Tuk.SizePanels)

	if IsAddOnLoaded("ElvUI_SLE") then
		local UB = ElvUI_SLE[1]:GetModule('UIButtons')
		hooksecurefunc(UB, "Initialize", function(self)
			UB.Holder:CreateDropdownButton("Addon", "TukStyle", "|cffff8000TukUI Style|r", nil, nil, function() E:ToggleConfig(); LibStub("AceConfigDialog-3.0-ElvUI"):SelectGroup("ElvUI", "TukUIStyle") end, "ElvUI_TukUIStyle")
			UB.Holder:FrameSize()
		end)
	end

	if E.private.install_complete and E.private.tukui_installed == nil then
		E:GetModule("PluginInstaller"):Queue(Tuk.InstallTable)
	end

	EP:RegisterPlugin(addon, Tuk.Options)
end

E:RegisterModule(Tuk:GetName())